      subroutine eev(g,mv2,p1,e1,n1,p2,e2,n2,eps,epsp,epsm)
c----------------------------------------------------------------------c
c Returns a contraction of the triple gauge boson coupling with 2 
c complex four vectors
c
c Input: g  - triple gauge boson coupling,
c        mv2- complex mass squared of the uncontracted gauge boson line,
c        p1,p2 - four momenta of the incoming bosons,
c        e1,e2 - polarization four vectors,
c        n1,n2 - No of polarizations of e1,e2.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 28 June, 2001; modified 29, June, 2001
c----------------------------------------------------------------------c

      implicit none

      integer :: n1,n2
      complex(8), dimension(0:3,n1) :: e1
      complex(8), dimension(0:3,n2) :: e2
      real(8), dimension(0:3) :: p1,p2,p3
      complex(8) :: g,mv2
      complex(8), dimension(0:3,n1,n2) :: eps,epsp,epsm

      integer :: i1,i2
      real(8) :: srr
      complex(8) :: gden,src,scc
      complex(8), parameter :: ocom=(0.d0,0.d0)

      p3=-p1-p2
      gden=g/(cmplx(srr(p3,p3),0.d0,8)-mv2)


      do i1=1,n1
       do i2=1,n2
         eps(:,i1,i2)=gden*(scc(e1(:,i1),e2(:,i2))*cmplx(p1-p2,0.d0,8)
     &                     +src(p2-p3,e1(:,i1))*e2(:,i2)
     &                     +src(p3-p1,e2(:,i2))*e1(:,i1))
        if (mv2 /= ocom) then
         eps(:,i1,i2)=eps(:,i1,i2)-src(p3,eps(:,i1,i2))*p3/mv2
        end if
        call spinc(eps(:,i1,i2),epsp(:,i1,i2),epsm(:,i1,i2))
       end do
      end do

      end 






