      subroutine fef(bu,e1p,e1m,g1p,g1m,u,mat,nb,n1,n)
c----------------------------------------------------------------------c
c Returns matrix elements: 
c
c              mat(nb,n1,n)=bu*e1*(g1m*P- + g1p*P+)*u
c
c Input: bu,u - spinors,
c        e1 - a generalized polarization vector in the spinor 
c             representation,
c        g1p - a vector boson coupling to the fermion line of the 
c              positive chirality, P+=(1+gamma_5)/2,
c        g1m - a vector boson couplings to the fermion line of the 
c              negative chirality, P-=(1-gamma_5)/2
c        nb,n1,n - numbers of polarization states.
c
c
c The gamma matrices are taken in the Weyl representation as in the 
c paper by K. Kolodziej, M. Zralek, Phys. Rev. D43 (1991) 3619
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 3 November, 2000
c----------------------------------------------------------------------c

      implicit none

      integer nb,n1,n

      complex(8) :: g1p,g1m

      complex(8), dimension(4,nb) :: bu
      complex(8), dimension(4,n) :: u
      complex(8), dimension(2,2,n1) :: e1p,e1m
      complex(8), dimension(nb,n1,n) :: mat

c Local variables:

      integer ib,i1,i

      complex(8), dimension(4) :: bu1

      do ib=1,nb
       do i1=1,n1
        bu1(:2)=g1m*matmul(bu(3:,ib),e1m(:,:,i1))
        bu1(3:)=g1p*matmul(bu(:2,ib),e1p(:,:,i1))
        do i=1,n
         mat(ib,i1,i)=bu1(1)*u(1,i)+bu1(2)*u(2,i)
     &               +bu1(3)*u(3,i)+bu1(4)*u(4,i)
        end do
       end do
      end do

      end




