      subroutine recpol(p,ps,mass,eps)
c----------------------------------------------------------------------c
c Returns real polarization vectors in the rectangular basis.
c Input: p(0:3) - particle four mometum,
c        ps(0:4) - spherical components of the particle four mometum,
c        mass - particle mass.
c
c The polarization vectors are defined as in the paper by K. Kolodziej, 
c M. Zralek, Phys. Rev. D43 (1991) 3619:
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 4 March, 1998
c----------------------------------------------------------------------c

      implicit none

      real(8) p(0:3),ps(0:4),mass,eps(0:3,3),zero,one,mone,gamma

      data zero,one,mone /0.d0,1.d0,-1.d0/


      save


      if (abs(ps(1)).lt.one) then

      eps(:,1)=(/ zero,
     &            ps(1)*ps(3),
     &            ps(1)*ps(4),
     &           -ps(2) /)

      eps(:,2)=(/ zero,
     &           -ps(4),
     &            ps(3),
     &            zero /)


      if (mass.gt.zero) then
        gamma=p(0)/mass
        eps(:,3)=(/ ps(0)/mass,
     &             gamma*ps(2)*ps(3),
     &             gamma*ps(2)*ps(4),
     &             gamma*ps(1) /)
      end if

      else if (ps(1).eq.one) then

      eps(:,1)=(/ zero,
     &            one,
     &            zero,
     &            zero /)

      eps(:,2)=(/ zero,
     &            zero,
     &            one,
     &            zero /)


      if (mass.gt.zero) then
        eps(:,3)=(/ ps(0)/mass,
     &               zero,
     &               zero,
     &              p(0)/mass /)
      end if

      else if (ps(1).eq.mone) then

      eps(:,1)=(/ zero,
     &            one,
     &            zero,
     &            zero /)

      eps(:,2)=(/ zero,
     &            zero,
     &            mone,
     &            zero/)

      if (mass.gt.zero) then
        eps(:,3)=(/ ps(0)/mass,
     &               zero,
     &               zero,
     &            -p(0)/mass /)

      end if

      end if

      end subroutine

