      subroutine spinr(p,x,y)
c----------------------------------------------------------------------c
c Returns the contractions: 
c      x = p(0)*I - p(i)*sigma(i) and y = p(0)*I + p(i)*sigma(i), 
c where I is the 2 x 2 unit matrix and sigma(i) are the Pauli matrices
c
c Input: the real four vector p
c
c                        Karol Kolodziej  
c                       kolodzie@us.edu.pl
c Zeuthen, 01.04.1998
c----------------------------------------------------------------------c

      implicit none
      real(8) p(0:3)
      complex(8) x(2,2),y(2,2)

      save

c                              x11  x21 
c                              x12  x22
      x=reshape((/cmplx(p(0)-p(3),0.d0,8),cmplx(-p(1),-p(2),8),          
     &            cmplx(-p(1),p(2),8),    cmplx(p(0)+p(3),0.d0,8) /),
     &                                                         (/2,2/))

c                              y11  y21 
c                              y12  y22
      y=reshape((/ x(2,2),              cmplx(p(1),p(2),8),
     &             cmplx(p(1),-p(2),8), x(1,1)             /),(/2,2/))

      end
