      subroutine vee(g,mv2,p2,e2,n2,p3,e3,n3,ih,gh,h,eps,epsp,epsm)
c----------------------------------------------------------------------c
c Returns a contraction of the triple gauge boson coupling with 2 
c complex four vectors
c
c Input: g  - triple gauge boson coupling,
c        mv2- complex mass squared of the uncontracted gauge boson line,
c        p2,p3 - four momenta of the incoming bosons,
c        e2,e3 - polarization four vectors,
c        n2,n3 - No of polarizations of e2,e3,
c        ih=1/else - Higgs exchange yes/no
c        gh - Higgs-W-W coupling,
c        h(n3) - Higgs scalar.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 29 June, 2001; modified: 2 July, 2001
c----------------------------------------------------------------------c

      implicit none

      integer :: n2,n3,ih
      complex(8), dimension(0:3,n2) :: e2
      complex(8), dimension(0:3,n3) :: e3
      real(8), dimension(0:3) :: p1,p2,p3
      complex(8) :: g,mv2,gh,h(n3)
      complex(8), dimension(0:3,n2,n3) :: eps,epsp,epsm

      integer :: i2,i3
      real(8) :: srr
      complex(8) :: gden,src,scc,den,ghden
      complex(8), parameter :: ocom=(0.d0,0.d0)

      p1=-p2-p3
      den=cmplx(srr(p1,p1),0.d0,8)-mv2
      gden=g/den
      ghden=gh/den

      do i2=1,n2
       do i3=1,n3
        eps(:,i2,i3)=gden*(scc(e2(:,i2),e3(:,i3))*cmplx(p2-p3,0.d0,8)
     &                    +src(p3-p1,e2(:,i2))*e3(:,i3)
     &                    +src(p1-p2,e3(:,i3))*e2(:,i2))
        if (ih == 1) then
         eps(:,i2,i3)=eps(:,i2,i3)+ghden*e2(:,i2)*h(i3)
        end if
         eps(:,i2,i3)=eps(:,i2,i3)-src(p1,eps(:,i2,i3))*p1/mv2
         call spinc(eps(:,i2,i3),epsp(:,i2,i3),epsm(:,i2,i3))
       end do
      end do

      end 






